package cn.com.qmth.export;

import java.io.File;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.UUID;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONObject;

public class MyConsumer extends Consumer<PaperExportDto> {
	private int maxqc = 200;
	private static String[] sucStr = new String[] { "对", "正确", "T", "是", "True", "right", "能" };
	private static String[] errStr = new String[] { "错", "错误", "F", "不正确", "否", "False", "wrong", "不能" };
	private static String paperDir = "d:/chuannong/paper/";
	private static String imgDir = "d:/chuannong/img";
	private static String imgDomain = "http://any.cnzx.info:81";

	private Pattern imgPat = Pattern.compile("<img[^<]+src=['\"]([^<\"]+)['\"][^<]*>");

	@Override
	public void consume(PaperExportDto dto) {
		Connection connect = null;
		File sub = new File(paperDir + dto.getCourseCode() + "/");
		sub.mkdir();
		try {
			Class.forName("com.mysql.cj.jdbc.Driver");

			String url = "jdbc:mysql://localhost:3306/" + dto.getDbName() + "?serverTimezone=GMT%2B8";

			String user = "root";

			String password = "123456";
			connect = DriverManager.getConnection(url, user, password);
			exportPaper(connect, dto);
			ChuanNongExportPaperByCourseCode.addDisposeCount();
		} catch (Exception e) {
			throw new RuntimeException(e);
		} finally {
			if (connect != null) {
				try {
					connect.close();
				} catch (SQLException e) {
				}
			}
		}
	}

	private List<KdQuestion> of(List<QuestionVo> vos, List<QuestionVo> subvosList) {
		List<KdQuestion> ret = new ArrayList<>();
		Map<Integer, List<QuestionVo>> submap = new HashMap<>();
		if (CollectionUtils.isNotEmpty(subvosList)) {
			for (QuestionVo vo : subvosList) {
				List<QuestionVo> tem = submap.get(vo.getPid());
				if (tem == null) {
					tem = new ArrayList<>();
					submap.put(vo.getPid(), tem);
				}
				tem.add(vo);
			}
		}
		for (QuestionVo vo : vos) {
			try {
				KdQuestion q = of(vo);
				if (QuesStructType.NESTED_ANSWER_QUESTION.equals(q.getQuesStructType())) {
					List<QuestionVo> subvos = submap.get(q.getId());
					try {
						q.setScore((double) subvos.size());
					} catch (Exception e) {
						throw e;
					}
					List<Double> subScores = new ArrayList<>();
					List<KdQuestion> subQues = new ArrayList<>();
					q.setSubScores(subScores);
					q.setSubQuestions(subQues);
//					int num = 0;
					for (QuestionVo subvo : subvos) {
//						num++;
						subScores.add(1.0);
						KdQuestion subq = of(subvo);
						subq.setId(null);
//						if (CusQuesStructType.cloze.equals(q.getCusType()) && StringUtils.isBlank(subq.getBody())) {
//							subq.setBody("___" + num + "___");
//						}
						subQues.add(subq);
					}
				}
				ret.add(q);
			} catch (StatusException e) {
				continue;
			}
		}
		return ret;
	}

	private KdQuestion of(QuestionVo vo) {
		KdQuestion q = new KdQuestion();
		q.setQuesStructType(vo.getqType());
		q.setDetailName(vo.getTypeName());
		q.setBody(vo.getBody());
		q.setDifficulty(vo.getDifficulty());
		q.setHaveAudio(false);
		q.setId(vo.getQid());
		q.setScore(1.0);
		disposeQuestionImg(q);

		return q;
	}

	private List<QuestionVo> getQuestion(Connection connect, PaperExportDto dto) throws SQLException, IOException {
		List<QuestionVo> qs = new ArrayList<>();
		PreparedStatement preState = null;
		ResultSet resultSet = null;
		try {
			String sql = " SELECT q.QuestionID qid,q.QuestionDesc body,t.QuestionTypeName typeName, q.AnswerTypeID atype,q.DiffCoef "
					+ " FROM Exam_e_QuestionInfo AS q " + " INNER JOIN Exam_e_QuestionType AS t "
					+ " ON t.QuestionTypeID = q.QuestionTypeID " + " WHERE  t.QuestionTypeName not LIKE '%上传%' "
					+ " AND q.Status=0 AND q.AuditingFlag=1 and q.OuterSystemID=3372 "
					+ " and q.ParentQuesID=0 and q.CourseCode='" + dto.getCourseCode() + "' ";

			preState = connect.prepareStatement(sql);

			resultSet = preState.executeQuery();

			while (resultSet.next()) {
				QuestionVo q = new QuestionVo();
				q.setQid(resultSet.getInt("qid"));
				String typeName = resultSet.getString("typeName");
				q.setTypeName(typeName);
				q.setDifficulty(getDiff(resultSet.getInt("DiffCoef")));
				q.setAtype(resultSet.getInt("atype"));
				q.setqType(getQuesType(q.getQid(), typeName, dto.getNestedQids()));
				q.setBody(resultSet.getString("body"));
				qs.add(q);
			}
			return qs;
		} finally {
			if (resultSet != null) {
				resultSet.close();
			}
			if (preState != null) {
				preState.close();
			}
		}
	}

	private YunkaiDifficulty getDiff(Integer diff) {
		if (diff == 1) {
			return YunkaiDifficulty.RONGYI;
		} else if (diff == 2) {
			return YunkaiDifficulty.JIAORONGYI;
		} else if (diff == 3) {
			return YunkaiDifficulty.ZHONGDENG;
		} else if (diff == 4) {
			return YunkaiDifficulty.JIAONAN;
		} else if (diff == 5) {
			return YunkaiDifficulty.KUNNAN;
		}
		throw new StatusException("难度值错误");
	}

	private QuesStructType getQuesType(Integer qid, String typeName, Set<Integer> nestedQids) {
		if (nestedQids.contains(qid)) {
			return QuesStructType.NESTED_ANSWER_QUESTION;
		}
		if (typeName.startsWith("单选")) {
			return QuesStructType.SINGLE_ANSWER_QUESTION;
		}
		if (typeName.startsWith("多选")) {
			return QuesStructType.MULTIPLE_ANSWER_QUESTION;
		}
		if (typeName.startsWith("判断")) {
			return QuesStructType.BOOL_ANSWER_QUESTION;
		}
		return QuesStructType.TEXT_ANSWER_QUESTION;
	}

	private List<QuestionVo> getSubQuestion(Connection connect, List<Integer> pids) throws SQLException, IOException {
		List<QuestionVo> qs = new ArrayList<>();
		if (CollectionUtils.isEmpty(pids)) {
			return qs;
		}
		PreparedStatement preState = null;
		ResultSet resultSet = null;
		try {
			String sql = " SELECT q.QuestionID qid,q.QuestionDesc body ,q.DiffCoef,q.ParentQuesID pid "
					+ " FROM Exam_e_QuestionInfo AS q  where q.ParentQuesID in (" + StringUtils.join(pids, ",")
					+ ") order by q.OrderFlag";

			preState = connect.prepareStatement(sql);

			resultSet = preState.executeQuery();

			while (resultSet.next()) {
				QuestionVo q = new QuestionVo();
				q.setQid(resultSet.getInt("qid"));
				q.setPid(resultSet.getInt("pid"));
				q.setDifficulty(getDiff(resultSet.getInt("DiffCoef")));
				q.setqType(QuesStructType.SINGLE_ANSWER_QUESTION);
				q.setBody(resultSet.getString("body"));
				qs.add(q);
			}
			return qs;
		} finally {
			if (resultSet != null) {
				resultSet.close();
			}
			if (preState != null) {
				preState.close();
			}
		}
	}

	private void disposeQuestionImg(KdQuestion q) {
		q.setBody(disposeImg(q.getBody(), q.getId()));
		if (CollectionUtils.isNotEmpty(q.getOptions())) {
			for (KdQuesOption o : q.getOptions()) {
				o.setBody(disposeImg(o.getBody(), q.getId()));
			}
		}
		q.setAnswer(disposeImg(q.getAnswer(), q.getId()));
	}

	private String disposeImg(String str, Integer qid) {
		try {
			if (StringUtils.isBlank(str)) {
				return str;
			}
			Matcher matcher = imgPat.matcher(str);
			Map<String, String> srcMap = new HashMap<>();
			while (matcher.find()) {
				String imgSrc = matcher.group(1).trim();
				if (imgSrc.startsWith("data:image/")) {

				} else if (imgSrc.startsWith("/")) {
					if (srcMap.get(imgSrc) == null) {
						String[] ss = imgSrc.split("\\?");
						String suff = ss[0].substring(ss[0].lastIndexOf("."));
						File img = new File(imgDir + "/" + UUID.randomUUID() + suff);
						FileUtil.saveUrlAs(imgDomain + imgSrc, img.getAbsolutePath());
						String base64 = FileUtil.fileToBase64Src(img);
						img.delete();
						srcMap.put(imgSrc, base64);
					}
				} else if (imgSrc.toLowerCase().trim().startsWith("http")) {
					if (srcMap.get(imgSrc) == null) {
						String[] ss = imgSrc.split("\\?");
						String suff = ss[0].substring(ss[0].lastIndexOf("."));
						File img = new File(imgDir + "/" + UUID.randomUUID() + suff);
						FileUtil.saveUrlAs(imgSrc, img.getAbsolutePath());
						String base64 = FileUtil.fileToBase64Src(img);
						img.delete();
						srcMap.put(imgSrc, base64);
					}
				} else {
					throw new StatusException("图片有误:" + qid);
				}
			}
			for (String imgSrc : srcMap.keySet()) {
				str = str.replaceAll(imgSrc, srcMap.get(imgSrc));
			}
			return str;
		} catch (Exception e) {
			throw new RuntimeException("图片有误:" + qid, e);
		}
	}

	private void exportPaper(Connection connect, PaperExportDto dto) throws Exception {
		List<QuestionVo> vos = getQuestion(connect, dto);
		if (CollectionUtils.isEmpty(vos)) {
			return;
		}
		List<Integer> pids = vos.stream().filter(e -> QuesStructType.NESTED_ANSWER_QUESTION.equals(e.getqType()))
				.map(QuestionVo::getQid).collect(Collectors.toList());
		List<QuestionVo> subvos = getSubQuestion(connect, pids);
		List<KdQuestion> qs = of(vos, subvos);
//		fillProp(connect, qs);
		fillAnswer(connect, qs);

		Map<DetailDto, List<KdQuestion>> qmap = new HashMap<>();
		for (KdQuestion q : qs) {
			DetailDto tem = new DetailDto(q.getTypeId(), q.getDetailName());
			List<KdQuestion> list = qmap.get(tem);
			if (list == null) {
				list = new ArrayList<>();
				qmap.put(tem, list);
			}
			list.add(q);
		}
		for (DetailDto qt : qmap.keySet()) {
			createPapers(qmap.get(qt), qt, dto);
		}
	}

	private void createPapers(List<KdQuestion> qs, DetailDto qt, PaperExportDto dto) {
		if (qs == null || qs.size() == 0) {
			return;
		}
		if (qs.size() <= maxqc) {
			createPaper(qs, qt, dto, 1);
		} else {
			int size = qs.size();
			int len = maxqc;
			int count = (size + len - 1) / len;

			for (int i = 0; i < count; i++) {
				List<KdQuestion> subList = qs.subList(i * len, ((i + 1) * len > size ? size : len * (i + 1)));
				createPaper(subList, qt, dto, i + 1);
			}
		}

	}

	private void createPaper(List<KdQuestion> qs, DetailDto qt, PaperExportDto dto, int indx) {
		if (qs.size() == 0) {
			return;
		}
		double score = 0.0;
		int unit = 0;
		for (KdQuestion q : qs) {
			if (CollectionUtils.isNotEmpty(q.getSubQuestions())) {
				unit = unit + q.getSubQuestions().size();
			} else {
				unit++;
			}
			score = Calculator.add(score, q.getScore(), 1);
		}
		String detailName = qt.getTypeName();
		KdPaper paper = new KdPaper();
		paper.setDetailCount(1);
		paper.setUnitCount(unit);
		paper.setTotalScore(score);
		paper.setName(dto.getPaperSuff() + detailName + "_" + indx);
		paper.setCourseCode(dto.getCourseCode());
		List<KdDetail> des = new ArrayList<>();
		KdDetail d = new KdDetail();
		d.setName(detailName);
		d.setNumber(1);
		d.setQuestionCount(unit);
		d.setTotalScore(score);
		d.setQuestions(qs);
		des.add(d);
		paper.setDetails(des);
		paper.setDetailCount(1);
		paper.setUnitCount(qs.size());
		File paperdir = new File(paperDir + dto.getCourseCode() + "/" + qt.getTypeId() + "/");
		paperdir.mkdirs();
		try {
			FileUtil.writeFile(paperdir.getAbsolutePath(), "/paper_" + indx + ".json", JSONObject.toJSONString(paper));
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	private void fillAnswer(Connection connect, List<KdQuestion> qs) {
		List<Answer> qps = new BatchGetDataUtil<Answer, KdQuestion>() {

			@Override
			protected List<Answer> getData(List<KdQuestion> paramList) {
				return getAnswerBatch(connect, paramList);
			}
		}.getDataForBatch(qs, 200);
		if (CollectionUtils.isEmpty(qps)) {
			return;
		}

		Map<Integer, List<Answer>> map = new HashMap<>();
		for (Answer qp : qps) {
			List<Answer> list = map.get(qp.getQuestionId());
			if (list == null) {
				list = new ArrayList<>();
				map.put(qp.getQuestionId(), list);
			}
			list.add(qp);
		}

		for (KdQuestion q : qs) {
			if (QuesStructType.SINGLE_ANSWER_QUESTION.equals(q.getQuesStructType())) {
				List<KdQuesOption> ops = new ArrayList<>();
				q.setOptions(ops);
				int num = 0;
				int answerCount = 0;
				for (Answer a : map.get(q.getId())) {
					num++;
					KdQuesOption op = new KdQuesOption();
					ops.add(op);
					op.setNumber(num);
					op.setBody(a.getBody());
					op.setSelect(a.getRight() == 1);
					if (op.getSelect()) {
						q.setAnswer(getOptionNum(num));
						answerCount++;
					}
				}
				if (answerCount == 0) {
					throw new StatusException("没有答案:" + q.getId());
				}
				if (answerCount > 1) {
					throw new StatusException("答案过多:" + q.getId());
				}
			} else if (QuesStructType.MULTIPLE_ANSWER_QUESTION.equals(q.getQuesStructType())) {
				List<String> as = new ArrayList<>();
				List<KdQuesOption> ops = new ArrayList<>();
				q.setOptions(ops);
				int num = 0;
				int answerCount = 0;
				for (Answer a : map.get(q.getId())) {
					num++;
					KdQuesOption op = new KdQuesOption();
					ops.add(op);
					op.setNumber(num);
					op.setBody(a.getBody());
					op.setSelect(a.getRight() == 1);
					if (op.getSelect()) {
						as.add(getOptionNum(num));
						answerCount++;
					}
				}
				if (answerCount == 0) {
					throw new StatusException("没有答案" + q.getId());
				}
				if (answerCount == 1) {
					throw new StatusException("答案只有一个:" + q.getId());
				}
				q.setAnswer(StringUtils.join(as, ","));
			} else if (QuesStructType.BOOL_ANSWER_QUESTION.equals(q.getQuesStructType())) {
				for (Answer a : map.get(q.getId())) {
					if (a.getRight() == 1) {
						q.setAnswer(getBool(a.getBody()));
					}
				}

			} else {
				StringBuilder sb = new StringBuilder();
				if (CollectionUtils.isNotEmpty(map.get(q.getId()))) {
					for (Answer a : map.get(q.getId())) {
						sb.append(a.getBody());
					}
				}
				q.setAnswer(sb.toString());
			}
		}
	}

	private String getBool(String val) {
		for (String suc : sucStr) {
			if (val.contains(suc)) {
				return "正确";
			}
		}
		for (String err : errStr) {
			if (val.contains(err)) {
				return "错误";
			}
		}
		return "正确";
	}

	private List<Answer> getAnswerBatch(Connection connect, List<KdQuestion> qs) {
		List<Answer> as = new ArrayList<>();
		List<Integer> ids = qs.stream().map(e -> e.getId()).collect(Collectors.toList());
		String idsstr = StringUtils.join(ids, ",");
		PreparedStatement preState = null;
		ResultSet resultSet = null;
		try {
			String sql = " select t.QuestionID qid,t.AnswerDesc answer_text,t.IsCorrent from exam_r_answerinfo t "
					+ " where t.QuestionID in (" + idsstr + ")  " + " order by t.QuestionID,t.OrderFlag ";
			preState = connect.prepareStatement(sql);

			resultSet = preState.executeQuery();

			while (resultSet.next()) {
				Integer qid = resultSet.getInt("qid");
				Answer a = new Answer();
				a.setBody(disposeImg(resultSet.getString("answer_text"), qid));
				a.setRight(resultSet.getInt("IsCorrent"));
				a.setQuestionId(qid);
				as.add(a);
			}
			return as;
		} catch (Exception e1) {
			throw new RuntimeException(e1);
		} finally {
			if (resultSet != null) {
				try {
					resultSet.close();
				} catch (SQLException e1) {
				}
			}
			if (preState != null) {
				try {
					preState.close();
				} catch (SQLException e1) {
				}
			}
		}
	}

	private String getOptionNum(int number) {
		char optionNum = (char) (65 + number);
		return String.valueOf(optionNum);
	}
}
