package cn.com.qmth.export;

import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections4.CollectionUtils;

import com.alibaba.fastjson.JSONObject;

public class MyConsumer2 extends Consumer<PaperExportDto> {
	private static String paperDir = "d:/chuannong/prop/";


	@Override
	public void consume(PaperExportDto dto) {
		Connection connect = null;
		try {
			Class.forName("com.mysql.cj.jdbc.Driver");

			String url = "jdbc:mysql://localhost:3306/"+dto.getDbName()+"?serverTimezone=GMT%2B8";

			String user = "root";

			String password = "123456";
			connect = DriverManager.getConnection(url, user, password);
			exportPaper(connect, dto);
			ChuanNongExportPaperByCourseCode.addDisposeCount();
		} catch (Exception e) {
			throw new RuntimeException(e);
		} finally {
			if (connect != null) {
				try {
					connect.close();
				} catch (SQLException e) {
				}
			}
		}
	}




	private void exportPaper(Connection connect, PaperExportDto dto) throws Exception {
		List<PropertyDto> props=getProperty(connect, dto.getCourseCode());
		if(CollectionUtils.isNotEmpty(props)) {
			FileUtil.writeFile(paperDir, dto.getCourseCode()+".json", JSONObject.toJSONString(props));
		}else {
			System.out.println("无文件："+dto.getCourseCode());
		}
	}
	private static List<PropertyDto> getProperty(Connection connect, String subjectCode) throws SQLException, IOException {
		List<PropertyDto> as = new ArrayList<>();
		PreparedStatement preState = null;
		ResultSet resultSet = null;
		try {
			String sql =" select t.ChapterID id,t.ParentChapterlID parent_id,t.root_id,t.ChapterTitle type_name "
					+" from exam_e_coursechapter t "
					+" where t.root_id=(select DISTINCT t.root_id "
					+" from exam_e_coursechapter t "
					+" where t.OuterSystemID=3372 and t.CourseCode='"+subjectCode+"' "
					+" and EXISTS(select 1 from exam_e_questioninfo q where t.ChapterID=q.ChapterID) "
					+" ) "
					+" order by t.Depth,t.OrderNumber ";
			preState = connect.prepareStatement(sql);

			resultSet = preState.executeQuery();
			Map<Long,PropertyDto> map=new HashMap<>();
			while (resultSet.next()) {
				Long rootId=resultSet.getLong("root_id");
				PropertyDto a = new PropertyDto();
				a.setId(resultSet.getLong("id"));
				a.setParentId(resultSet.getLong("parent_id"));
				a.setName(resultSet.getString("type_name"));
				if(a.getParentId()==0) {
					as.add(a);
				}else {
					PropertyDto parent=map.get(a.getParentId());
					if(parent==null) {
						throw new RuntimeException("parent is null:"+a.getId());
					}
					if(parent.getParentId()==0) {
						a.setName(a.getName());
					}else {
						a.setName(parent.getName()+"|"+a.getName());
					}
					PropertyDto root=map.get(rootId);
					root.addSub(a);
				}
				map.put(a.getId(), a);
			}
			return as;
		} finally {
			if (resultSet != null) {
				resultSet.close();
			}
			if (preState != null) {
				preState.close();
			}
		}
	}

	@Override
	public void initResult() {

	}
}
